<?php declare(strict_types=1);

namespace Flat101\EnhancedEcommerce\Model\Config\Source;

use Magento\Framework\Data\OptionSourceInterface;

class CustomizedCatalogImpressionList implements OptionSourceInterface
{
    CONST USE_CUSTOM_NAME = 1;
    CONST USE_CATEGORY_NAME = 2;

    /**
     * Options getter
     *
     * @return array
     */
    public function toOptionArray()
    {
        return [
            ['label' => __('Use custom name for listing'), 'value' => self::USE_CUSTOM_NAME],
            ['label' => __('Use category name'), 'value' => self::USE_CATEGORY_NAME]
        ];
    }

    /**
     * Get options in "key-value" format
     *
     * @return array
     */
    public function toArray()
    {
        return [
            [self::USE_CUSTOM_NAME => __('Use custom name for listing')],
            [self::USE_CATEGORY_NAME => __('Use category name')]
        ];
    }
}
