<?php

namespace Flat101\EnhancedEcommerce\Model;

use Flat101\EnhancedEcommerce\Helper\Config;
use Magento\Catalog\Model\ResourceModel\Product\CollectionFactory;
use Magento\Checkout\Model\ConfigProviderInterface;
use Flat101\EnhancedEcommerce\Model\DataLayerGa4\Impressions\CheckoutImpressionView as CheckoutImpressionViewGa4;
use Flat101\EnhancedEcommerce\Model\DataLayerGa4\Impressions\CheckoutImpressionView as CheckoutImpressionViewUa;
use Magento\Framework\Serialize\SerializerInterface;

class ConfigProvider implements ConfigProviderInterface
{
    /**
     * @var CheckoutImpressionViewUa
     */
    private CheckoutImpressionViewUa $checkoutImpressionViewGa4;
    /**
     * @var CheckoutImpressionViewUa
     */
    private CheckoutImpressionViewUa $checkoutImpressionViewUa;

    /** @var Config */
    protected $config;
    /**
     * @var CollectionFactory
     */
    private CollectionFactory $collectionFactory;
    /**
     * @var SerializerInterface
     */
    private SerializerInterface $serializer;

    public function __construct(
        CheckoutImpressionViewGa4 $checkoutImpressionViewGa4,
        CheckoutImpressionViewUa $checkoutImpressionViewUa,
        Config $config,
        CollectionFactory $collectionFactory,
        SerializerInterface $serializer
    ) {
        $this->checkoutImpressionViewGa4 = $checkoutImpressionViewGa4;
        $this->checkoutImpressionViewUa = $checkoutImpressionViewUa;
        $this->config = $config;
        $this->collectionFactory = $collectionFactory;
        $this->serializer = $serializer;
    }

    public function getConfig(): array
    {
        $impressionDataType = [];
        $impressionDataType['GA4'] = $this->checkoutImpressionViewGa4->getLayer()->getData();
        if (!$this->config->getIsDisabledUaDatalayer()) {
            $impressionDataType['UA'] = $this->checkoutImpressionViewUa->getLayer();
        }

        return $impressionDataType;
    }

}
