<?php
declare(strict_types=1);

namespace Flat101\EnhancedEcommerce\Model\DataLayerGa4\Generator;

use Flat101\EnhancedEcommerce\Model\DataLayerGa4\Builder\ImpressionBuilder;
use Flat101\EnhancedEcommerce\Model\DataLayerGa4\Dto;
use Magento\Catalog\Model\Product as ProductEntity;

class Impression
{
    /** @var ImpressionBuilder */
    private $impressionBuilder;

    public function __construct(ImpressionBuilder $impressionBuilder)
    {
        $this->impressionBuilder = $impressionBuilder;
    }

    public function generate(ProductEntity $entity, string $list, array $additionalInfo): Dto\Impression\ImpressionProduct
    {
        return $this->impressionBuilder->build($entity, $list, $additionalInfo);
    }
}
